com.smartgwt.client.widgets.drawing

## Class DrawLabel

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawLabel

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawLabel
      extends DrawItem

  DrawItem subclass to render a single-line text label.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawLabel()`
    `DrawLabel(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getAlignment()` Sets the text alignment from the x position.
    `Point` | `getCenter()` Get the center point of the label.
    `java.lang.String` | `getContents()` This is the content that will exist as the label.
    `java.lang.String` | `getEditProxyConstructor()` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `java.lang.String` | `getFontFamily()` Font family name, similar to the CSS font-family attribute.
    `int` | `getFontSize()` Font size in pixels, similar to the CSS font-size attribute.
    `java.lang.String` | `getFontStyle()` Font style, similar to the CSS font-style attribute, eg "normal", "italic".
    `java.lang.String` | `getFontWeight()` Font weight, similar to the CSS font-weight attribute, eg "normal", "bold".
    `KnobType[]` | `getKnobs()` DrawLabel only supports the `KnobType.MOVE` knob type.
    `int` | `getLeft()` Sets the amount from the left of its positioning that the element should be placed.
    `java.lang.String` | `getLineColor()` The text color of the label.
    `static DrawLabel` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `float` | `getRotation()` Deprecated. `GwtFloatVsDouble`
    `double` | `getRotationAsDouble()` Rotation in degrees about the `top` `left` corner.
    `int` | `getTop()` Sets the amount from the top of its positioning that the element should be placed.
    `void` | `moveBy(int dX, int dY)` Change the label's `left` and `top` by the specified amounts.
    `void` | `moveTo(java.lang.Integer left, java.lang.Integer top)` Move the label to the absolute x, y coordinates
    `void` | `setAlignment(java.lang.String alignment)` Sets the text alignment from the x position.
    `void` | `setContents(java.lang.String contents)` This is the content that will exist as the label.
    `static void` | `setDefaultProperties(DrawLabel drawLabelProperties)` Class level method to set the default properties of this class.
    `void` | `setEditProxyConstructor(java.lang.String editProxyConstructor)` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `void` | `setFontFamily(java.lang.String fontFamily)` Font family name, similar to the CSS font-family attribute.
    `void` | `setFontSize(int fontSize)` Font size in pixels, similar to the CSS font-size attribute.
    `void` | `setFontStyle(java.lang.String fontStyle)` Font style, similar to the CSS font-style attribute, eg "normal", "italic".
    `void` | `setFontWeight(java.lang.String fontWeight)` Font weight, similar to the CSS font-weight attribute, eg "normal", "bold".
    `void` | `setKnobs(KnobType... knobs)` DrawLabel only supports the `KnobType.MOVE` knob type.
    `void` | `setLeft(int left)` Sets the amount from the left of its positioning that the element should be placed.
    `void` | `setLineColor(java.lang.String lineColor)` The text color of the label.
    `void` | `setRotation(double rotation)` Rotation in degrees about the `top` `left` corner.
    `void` | `setRotation(float rotation)` Deprecated. `GwtFloatVsDouble`
    `void` | `setTop(int top)` Sets the amount from the top of its positioning that the element should be placed.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, changeAutoChildDefaults, changeAutoChildDefaults, changeAutoChildDefaults, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getBoundingBoxAsDouble, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getEndArrow, getEndKnob, getEventOpaque, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getLineCap, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getScale, getShadow, getShowHover, getShowResizeOutline, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTranslate, getXShearFactor, getYShearFactor, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, isPointInPath, resizeBy, resizeTo, rotateBy, rotateTo, scaleBy, scaleTo, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEndArrow, setEventOpaque, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setLineCap, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setScale, setShadow, setShowHover, setShowResizeOutline, setStartArrow, setTranslate, setXShearFactor, setYShearFactor, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isCreated, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setFactoryCreated, setID, setJavaScriptObject, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawLabel

          public DrawLabel()

    - #### DrawLabel

          public DrawLabel(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawLabel getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setAlignment

          public void setAlignment(java.lang.String alignment)
                            throws java.lang.IllegalStateException

      Sets the text alignment from the x position. Similar to html5 context.textAlign, eg "start", "center", "end"
      Parameters:
        `alignment` - Default value is "start"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getAlignment

          public java.lang.String getAlignment()

      Sets the text alignment from the x position. Similar to html5 context.textAlign, eg "start", "center", "end"
      Returns:
        String

    - #### setContents

          public void setContents(java.lang.String contents)

      This is the content that will exist as the label.
      If this method is called after the component has been drawn/initialized: Sets this DrawLabel's `contents`.
      Parameters:
        `contents` - the new contents.. Default value is null

    - #### getContents

          public java.lang.String getContents()

      This is the content that will exist as the label.
      Returns:
        String

    - #### setEditProxyConstructor

          public void setEditProxyConstructor(java.lang.String editProxyConstructor)
                                       throws java.lang.IllegalStateException

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `setEditProxyConstructor` in class `DrawItem`
      Parameters:
        `editProxyConstructor` - See `SCClassName` . Default value is "DrawLabelEditProxy"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getEditProxyConstructor

          public java.lang.String getEditProxyConstructor()

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `getEditProxyConstructor` in class `DrawItem`
      Returns:
        See `SCClassName`

    - #### setFontFamily

          public void setFontFamily(java.lang.String fontFamily)
                             throws java.lang.IllegalStateException

      Font family name, similar to the CSS font-family attribute.
      Parameters:
        `fontFamily` - Default value is "Tahoma"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getFontFamily

          public java.lang.String getFontFamily()

      Font family name, similar to the CSS font-family attribute.
      Returns:
        String

    - #### setFontSize

          public void setFontSize(int fontSize)

      Font size in pixels, similar to the CSS font-size attribute.
      If this method is called after the component has been drawn/initialized: Sets this DrawLabel's `fontSize`.
      Parameters:
        `fontSize` - the new font size in pixels.. Default value is 18

    - #### getFontSize

          public int getFontSize()

      Font size in pixels, similar to the CSS font-size attribute.
      Returns:
        int

    - #### setFontStyle

          public void setFontStyle(java.lang.String fontStyle)
                            throws java.lang.IllegalStateException

      Font style, similar to the CSS font-style attribute, eg "normal", "italic".
      Parameters:
        `fontStyle` - Default value is "normal"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getFontStyle

          public java.lang.String getFontStyle()

      Font style, similar to the CSS font-style attribute, eg "normal", "italic".
      Returns:
        String

    - #### setFontWeight

          public void setFontWeight(java.lang.String fontWeight)
                             throws java.lang.IllegalStateException

      Font weight, similar to the CSS font-weight attribute, eg "normal", "bold".
      Parameters:
        `fontWeight` - Default value is "bold"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getFontWeight

          public java.lang.String getFontWeight()

      Font weight, similar to the CSS font-weight attribute, eg "normal", "bold".
      Returns:
        String

    - #### setKnobs

          public void setKnobs(KnobType... knobs)
                        throws java.lang.IllegalStateException

      DrawLabel only supports the `KnobType.MOVE` knob type.
      Overrides:
        `setKnobs` in class `DrawItem`
      Parameters:
        `knobs` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `DrawItem.setKnobs(com.smartgwt.client.types.KnobType...)`, Diagramming Example

    - #### getKnobs

          public KnobType[] getKnobs()

      DrawLabel only supports the `KnobType.MOVE` knob type.
      Overrides:
        `getKnobs` in class `DrawItem`
      Returns:
        KnobType...
      See Also:
        `DrawItem.getKnobs()`, Diagramming Example

    - #### setLeft

          public void setLeft(int left)
                       throws java.lang.IllegalStateException

      Sets the amount from the left of its positioning that the element should be placed.
      Parameters:
        `left` - Default value is 0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getLeft

          public int getLeft()

      Sets the amount from the left of its positioning that the element should be placed.
      Returns:
        int

    - #### setLineColor

          public void setLineColor(java.lang.String lineColor)

      The text color of the label.
      If this method is called after the component has been drawn/initialized: Sets the text color of the label.
      Overrides:
        `setLineColor` in class `DrawItem`
      Parameters:
        `lineColor` - new text color. See `CSSColor` . Default value is "#808080"

    - #### getLineColor

          public java.lang.String getLineColor()

      The text color of the label.
      Overrides:
        `getLineColor` in class `DrawItem`
      Returns:
        See `CSSColor`

    - #### setRotation

          public void setRotation(float rotation)
                           throws java.lang.IllegalStateException

      Deprecated. `GwtFloatVsDouble`
      Rotation in degrees about the `top` `left` corner. The positive direction is clockwise.

      NOTE: In Internet Explorer 8 and earlier, only rotation by 0 or 90 degrees is supported.

      Overrides:
        `setRotation` in class `DrawItem`
      Parameters:
        `rotation` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRotation

          public float getRotation()

      Deprecated. `GwtFloatVsDouble`
      Rotation in degrees about the `top` `left` corner. The positive direction is clockwise.

      NOTE: In Internet Explorer 8 and earlier, only rotation by 0 or 90 degrees is supported.

      Overrides:
        `getRotation` in class `DrawItem`
      Returns:
        float

    - #### setRotation

          public void setRotation(double rotation)
                           throws java.lang.IllegalStateException

      Rotation in degrees about the `top` `left` corner. The positive direction is clockwise.

      NOTE: In Internet Explorer 8 and earlier, only rotation by 0 or 90 degrees is supported.

      Overrides:
        `setRotation` in class `DrawItem`
      Parameters:
        `rotation` - Default value is 0.0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getRotationAsDouble

          public double getRotationAsDouble()

      Rotation in degrees about the `top` `left` corner. The positive direction is clockwise.

      NOTE: In Internet Explorer 8 and earlier, only rotation by 0 or 90 degrees is supported.

      Overrides:
        `getRotationAsDouble` in class `DrawItem`
      Returns:
        double

    - #### setTop

          public void setTop(int top)
                      throws java.lang.IllegalStateException

      Sets the amount from the top of its positioning that the element should be placed.
      Parameters:
        `top` - Default value is 0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getTop

          public int getTop()

      Sets the amount from the top of its positioning that the element should be placed.
      Returns:
        int

    - #### getCenter

          public Point getCenter()

      Get the center point of the label.
      Overrides:
        `getCenter` in class `DrawItem`
      Returns:
        the center point

    - #### moveBy

          public void moveBy(int dX,
                    int dY)

      Change the label's `left` and `top` by the specified amounts.
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to move horizontally
        `dY` - number of pixels to move vertically

    - #### moveTo

          public void moveTo(java.lang.Integer left,
                    java.lang.Integer top)

      Move the label to the absolute x, y coordinates
      Overrides:
        `moveTo` in class `DrawItem`
      Parameters:
        `left` - new startLeft coordinate in pixels
        `top` - new startTop coordinate in pixels

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawLabel drawLabelProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `drawLabelProperties` - properties that should be used as new defaults when instances of this class are created